using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Xamarin.Forms;
using Native = Com.Syncfusion.Gauges.SfDigitalGauge.SfDigitalGauge;

using Xamarin.Forms.Platform.Android;
using System.Reflection;
using Syncfusion.SfGauge.XForms;
using Syncfusion.SfGauge.XForms.Droid;

[assembly: ExportRenderer(typeof(Syncfusion.SfGauge.XForms.SfDigitalGauge), typeof(Syncfusion.SfGauge.XForms.Droid.SfDigitalGaugeRenderer))]

namespace Syncfusion.SfGauge.XForms.Droid
{
	public class SfDigitalGaugeRenderer : ViewRenderer<Syncfusion.SfGauge.XForms.SfDigitalGauge, Native>
	{
		SfDigitalGauge gauge;
		Native nativeGauge;
		public SfDigitalGaugeRenderer()
		{

		}
		SfDigitalGaugeMapping sfdigitalGaugeMapping = new SfDigitalGaugeMapping();
		protected override void OnElementChanged(ElementChangedEventArgs<Syncfusion.SfGauge.XForms.SfDigitalGauge> e)
		{
			base.OnElementChanged(e);
			if (e.NewElement != null)
			{
				gauge = e.NewElement;
				nativeGauge = new Native (Forms.Context);
				List<string> propertiesNames = GetPropertiesChanged (typeof(SfDigitalGauge), gauge);
				foreach (var name in propertiesNames) {
					sfdigitalGaugeMapping.OnGaugePropertiesChanged (name, gauge, nativeGauge);
				}

				SetNativeControl (nativeGauge);
				propertiesNames.Clear ();
			}
		}

		protected override void OnElementPropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
		{
			SfDigitalGaugeMapping sfDigitalGaugeMapping;
			if (sender is SfDigitalGauge)
			{
				sfDigitalGaugeMapping = new SfDigitalGaugeMapping();
				sfDigitalGaugeMapping.OnGaugePropertiesChanged(e.PropertyName, gauge, nativeGauge);
			}
		}

		public static List<string> GetPropertiesChanged(Type type, Object obj)
		{
			var properties = type.GetProperties();
			List<string> propertiesList = new List<string>();
			foreach (var item in properties)
			{
				propertiesList.Add(item.Name);
			}
			return propertiesList;
		}


		public static Android.Graphics.Color GetRGB(float hue, float saturation, float luminosity)
		{
			int r = 0, g = 0, b = 0;
			if (saturation == 0)
			{
				r = g = b = (int)(luminosity * 255.0f + 0.5f);
			}
			else
			{
				float h = (hue - (float)Math.Floor(hue)) * 6.0f;
				float f = h - (float)Math.Floor(h);
				float p = luminosity * (1.0f - saturation);
				float q = luminosity * (1.0f - saturation * f);
				float t = luminosity * (1.0f - (saturation * (1.0f - f)));
				switch ((int)h)
				{
				case 0:
					r = (int)(luminosity * 255.0f + 0.5f);
					g = (int)(t * 255.0f + 0.5f);
					b = (int)(p * 255.0f + 0.5f);
					break;
				case 1:
					r = (int)(q * 255.0f + 0.5f);
					g = (int)(luminosity * 255.0f + 0.5f);
					b = (int)(p * 255.0f + 0.5f);
					break;
				case 2:
					r = (int)(p * 255.0f + 0.5f);
					g = (int)(luminosity * 255.0f + 0.5f);
					b = (int)(t * 255.0f + 0.5f);
					break;
				case 3:
					r = (int)(p * 255.0f + 0.5f);
					g = (int)(q * 255.0f + 0.5f);
					b = (int)(luminosity * 255.0f + 0.5f);
					break;
				case 4:
					r = (int)(t * 255.0f + 0.5f);
					g = (int)(p * 255.0f + 0.5f);
					b = (int)(luminosity * 255.0f + 0.5f);
					break;
				case 5:
					r = (int)(luminosity * 255.0f + 0.5f);
					g = (int)(p * 255.0f + 0.5f);
					b = (int)(q * 255.0f + 0.5f);
					break;
				}
			}
			return new Android.Graphics.Color(r,g,b); 
		}
	}
}