using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Xamarin.Forms;
using Native = Com.Syncfusion.Gauges.SfCircularGauge.SfCircularGauge;

using Xamarin.Forms.Platform.Android;
using System.Reflection;

using Syncfusion.SfGauge.XForms;

[assembly: ExportRenderer(typeof(Syncfusion.SfGauge.XForms.SfCircularGauge), typeof(Syncfusion.SfGauge.XForms.Droid.SfGaugeRenderer))]

namespace Syncfusion.SfGauge.XForms.Droid
{
    public class SfGaugeRenderer : ViewRenderer<Syncfusion.SfGauge.XForms.SfCircularGauge, Com.Syncfusion.Gauges.SfCircularGauge.SfCircularGauge>
    {
        SfCircularGauge gauge;
        public Native nativeGauge;
        public SfGaugeRenderer()
        {

        }
        SfCircularGaugeMapping sfCircularGaugeMapping = new SfCircularGaugeMapping();
        protected override void OnElementChanged(ElementChangedEventArgs<Syncfusion.SfGauge.XForms.SfCircularGauge> e)
        {
            base.OnElementChanged(e);
			if (e.NewElement != null) 
			{
				gauge = e.NewElement;
				nativeGauge = new Native (Forms.Context);
				gauge.SizeChanged += gauge_SizeChanged;
				List<string> propertiesNames = GetPropertiesChanged (typeof(SfCircularGauge), gauge);
				foreach (var name in propertiesNames) {
					sfCircularGaugeMapping.OnGaugePropertiesChanged (name, gauge, nativeGauge);
				}

				SetNativeControl (nativeGauge);
				propertiesNames.Clear ();
			}
        }

        void gauge_SizeChanged(object sender, EventArgs e)
        {
            double size = (sender as SfCircularGauge).Width < (sender as SfCircularGauge).Height ? (sender as SfCircularGauge).Width : (sender as SfCircularGauge).Height;
            gauge.HeightRequest = size;
            gauge.WidthRequest = size;
        }
        protected override void OnElementPropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            SfCircularGaugeMapping sfCircularGaugeMapping;
            if (sender is SfCircularGauge)
            {
                sfCircularGaugeMapping = new SfCircularGaugeMapping();
                sfCircularGaugeMapping.OnGaugePropertiesChanged(e.PropertyName, gauge, nativeGauge);
            }
        }

        public static List<string> GetPropertiesChanged(Type type, Object obj)
        {
            var properties = type.GetProperties();
            List<string> propertiesList = new List<string>();
            foreach (var item in properties)
            {
                propertiesList.Add(item.Name);
            }
            return propertiesList;
        }
    }
}
 
