using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;

using Native = Com.Syncfusion.Gauges.SfLinearGauge;
using Syncfusion.SfGauge.XForms;
using Com.Syncfusion.Gauges.SfCircularGauge.Enums;

namespace Syncfusion.SfGauge.XForms.Droid
{
    public class LinearPointerMapping
    {
		public Native.SfLinearGauge gauge;
		Native.SymbolPointer newPointer;
		internal double scalebar=0;
		public Native.LinearPointer GetPointer(LinearPointer formPointer)
        {
			if (formPointer is SymbolPointer)
            {
				newPointer = new Native.SymbolPointer();
				List<string> properties = SfLinearGaugeRenderer.GetPropertiesChanged(typeof(SymbolPointer), formPointer);
                foreach (var propertyName in properties)
                {
					OnPointerPropertiesChanged(propertyName, (SymbolPointer)formPointer, (Native.SymbolPointer)newPointer);
                }

                return newPointer;
            }
            else
            {
				Native.BarPointer newPointer = new Native.BarPointer();
				List<string> properties = SfLinearGaugeRenderer.GetPropertiesChanged(typeof(BarPointer), formPointer);
                foreach (var propertyName in properties)
                {
                    OnPointerPropertiesChanged(propertyName, (BarPointer)formPointer, (Native.BarPointer)newPointer);
                }
                return newPointer;
            }
            
        }

        public void OnPointerPropertiesChanged(string propertyName, SymbolPointer formPointer, Native.SymbolPointer nativePointer)
        {

			if (propertyName ==SymbolPointer.ValueProperty.PropertyName)
            {
				if (this.gauge != null)
				{
					if (this.gauge.Scales != null && this.gauge.Scales.Count > 0 && this.gauge.Scales[0].Pointers != null && this.gauge.Scales[0].Pointers.Count > 0)
					{
						foreach (Native.LinearPointer pointer in this.gauge.Scales[0].Pointers)
						{
							if (pointer is Native.SymbolPointer) {
								pointer.Value = (float)formPointer.Value;
							}
						}
					}
				}
//                (nativePointer).Value = formPointer.Value;
            }
			else if (propertyName ==SymbolPointer.ColorProperty.PropertyName)
            {
                (nativePointer).Color = new global::Android.Graphics.Color() { A = (byte)(formPointer.Color.A * 255), R = (byte)(formPointer.Color.R * 255), G = (byte)(formPointer.Color.G * 255), B = (byte)(formPointer.Color.B * 255) };
            }
			else if (propertyName ==SymbolPointer.OffsetProperty.PropertyName)
            {
				(nativePointer).Offset = ((scalebar*2/30)/13.5)+formPointer.Offset;
            }
			else if (propertyName ==SymbolPointer.ThicknessProperty.PropertyName)
			{
//				(nativePointer).StrokeWidth = formPointer.Thickness;
			}
			else if (propertyName ==SymbolPointer.EnableAnimationProperty.PropertyName)
            {
                (nativePointer).EnableAnimation = formPointer.EnableAnimation;
            }

//            if (this.gauge != null)
//            {
//				if (this.gauge.Scales != null && this.gauge.Scales.Count > 0 && this.gauge.Scales[0].Pointers != null && this.gauge.Scales[0].Pointers.Count > 0)
//                {
//					foreach (Native.LinearPointer pointer in this.gauge.Scales[0].Pointers)
//                    {
//						if (pointer is Native.SymbolPointer) {
//							//pointer.EnableAnimation = true;
//							pointer.Value = (float)formPointer.Value;
//						}
//                    }
//                }
//            }
        }

        public void OnPointerPropertiesChanged(string propertyName, BarPointer formPointer, Native.BarPointer nativePointer)
        {
            if (propertyName ==LinearPointer.ValueProperty.PropertyName)
            {
				if (this.gauge.Scales != null && this.gauge.Scales.Count > 0 && this.gauge.Scales[0].Pointers != null && this.gauge.Scales[0].Pointers.Count > 0)
				{
					foreach (Native.LinearPointer pointer in this.gauge.Scales[0].Pointers)
					{
						if (pointer is Native.BarPointer) {
							pointer.Value = (float)formPointer.Value;
						}
					}
				}
            }
            else if (propertyName ==LinearPointer.ColorProperty.PropertyName)
            {
                (nativePointer).Color = new global::Android.Graphics.Color() { A = (byte)(formPointer.Color.A * 255), R = (byte)(formPointer.Color.R * 255), G = (byte)(formPointer.Color.G * 255), B = (byte)(formPointer.Color.B * 255) };
            }
            else if (propertyName ==LinearPointer.ThicknessProperty.PropertyName)
            {
				(nativePointer).StrokeWidth = formPointer.Thickness;
            }
            else if (propertyName ==LinearPointer.EnableAnimationProperty.PropertyName)
            {
                (nativePointer).EnableAnimation = formPointer.EnableAnimation;
            }
//			if (this.gauge != null)
//			{
//				if (this.gauge.Scales != null && this.gauge.Scales.Count > 0 && this.gauge.Scales[0].Pointers != null && this.gauge.Scales[0].Pointers.Count > 0)
//				{
//					foreach (Native.LinearPointer pointer in this.gauge.Scales[0].Pointers)
//					{
//						if (pointer is Native.BarPointer) {
//							//pointer.EnableAnimation = true;
//							pointer.Value = (float)formPointer.Value;
//						}
//					}
//				}
//			}
        }
    }
}