using System;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;

using Native =  Com.Syncfusion.Gauges.SfLinearGauge;
using Syncfusion.SfGauge.XForms;
using System.Collections.Generic;


namespace Syncfusion.SfGauge.XForms.Droid
{
    public class SfLinearGaugeMapping
    {
        #region Properties

		Native.SfLinearGauge gauge;
        LinearScaleMapping scaleMapping;
		Native.LinearScale newScale;
        #endregion

        #region Methods

		public void OnGaugePropertiesChanged(string propertyName, SfLinearGauge formsGauge, Native.SfLinearGauge nativeGauge)
        {
			newScale = new Native.LinearScale();
            gauge = nativeGauge;
           
			scaleMapping = new LinearScaleMapping();
            scaleMapping.gauge = gauge;

			if (propertyName == SfLinearGauge.OrientationProperty.PropertyName)
			{
				if(formsGauge.Orientation==Orientation.OrientationHorizontal)
					nativeGauge.SetOrientation( Com.Syncfusion.Gauges.SfLinearGauge.SfLinearGauge.Orientation.Horizontal);
				else
					nativeGauge.SetOrientation ( Com.Syncfusion.Gauges.SfLinearGauge.SfLinearGauge.Orientation.Vertical);
			}
			if (propertyName == SfLinearGauge.ScalesProperty.PropertyName)
            {
                if (formsGauge.Scales != null)
                {
					List<Native.LinearScale> scales = new List<Native.LinearScale> ();
                    foreach (LinearScale FormScale in formsGauge.Scales)
                    {
                         FormScale.BindingContext = formsGauge.BindingContext;
                        scaleMapping.gauge = nativeGauge;
                        newScale = scaleMapping.GetScale(FormScale);
                        FormScale.BindingContext = formsGauge.BindingContext;
						scales.Add(newScale);
                    }
					nativeGauge.Scales = scales;
                }
            }
          
			else if (propertyName == SfLinearGauge.GaugeHeadersProperty.PropertyName)
            {
                if (formsGauge.Headers != null)
                {
                    LinearHeaderMapping gaugeHeaderMapping;
					foreach (LinearHeader FormHeader in formsGauge.Headers)
                    {
                        FormHeader.BindingContext = formsGauge.BindingContext;
						gaugeHeaderMapping = new LinearHeaderMapping();
                        var newHeader = gaugeHeaderMapping.GetHeader(FormHeader);
                        nativeGauge.Headers.Add(newHeader);
                    }
                }
            }
//            nativeGauge.FrameType = Native.Enums.FrameTypes.None;
        }
        #endregion
    }
}